//  tester
//
//  Copyright (c) 2005 Mike Willegal
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import java.awt.*;
import java.awt.event.*;
import	java.util.*;
import javax.swing.*;
import java.io.*;
import javax.comm.*;

/*
startflag:		.BYTE 1
error:			.BYTE 1

hfrstopen:		.BYTE 1
m2frstopen:		.BYTE 1	
m1frstopen:		.BYTE 1
lfrstopen:		.BYTE 1
	
hfrstcls:		.BYTE 1
m2frstcls:		.BYTE 1
m1frstcls:		.BYTE 1
lfrstcls:		.BYTE 1

hsecopen:		.BYTE 1
m2secopen:		.BYTE 1
m1secopen:		.BYTE 1
lsecopen:		.BYTE 1

hseccls:		.BYTE 1
m2seccls:		.BYTE 1
m1seccls:		.BYTE 1
lseccls:		.BYTE 1

endflag:		.BYTE 1
*/

public class Monitor implements Runnable,  ActionListener {
	tester applet;
        volatile  boolean  threadSuspended;
	float exposure_left, exposure_right, speed_1st, speed_2nd;
        int frstopen, frstclose, secopen, secclose;
	int result;
	int reason;
	int levelon;
	int leveloff;
        int portCount;
        boolean running;
        public SerialPort serialPort = null;
        InputStream inputStream;
        OutputStream outputStream;
        JRadioButtonMenuItem miPort[];
        String list[];
        final float clock = 3686400;


        public void go () {
            running = true;
        }

        public void halt () {
            running = false;
        }

 	public void run () {
            running = false;
            int numBytes, ptr, i;
            String response = null;
            boolean goodresponse = false;
            int nextbyte;
            byte readBuffer[] = new byte[21];
            String waitstring = "Waiting \n";
            float factor = clock /13/1000;
            int check;

            while (true) {
                if (!running) {
//                        System.out.println("suspended");
                        try {
                            Thread.currentThread().sleep(1000);
                        } catch (InterruptedException e){}
                } else {
                        try {
                            goodresponse = false;
                            do {
                                if (inputStream.available() >0 ) {
                                    System.out.print("Reading com port\n");	
                                    nextbyte = inputStream.read();
                                    if (nextbyte != 0xaa) {
                                        System.out.print("start not found:start char:" + Integer.toHexString(nextbyte) +"\n");
                                    } else {
                                       System.out.print("starting read\n");
                                        while (inputStream.available() < 21 ) {}
                                        numBytes = inputStream.read(readBuffer, 0x0, readBuffer.length);
                                        if (numBytes != readBuffer.length  || readBuffer[readBuffer.length-2] != 0x55) {
                                            System.out.print("bad read: termination char" + Integer.toHexString((int)readBuffer[readBuffer.length-2]) +"\n");
                                        } else {
                                            /* check sum verification */
                                            check = 0xaa;
                                            for (i = 0; i<readBuffer.length-1; i++) {
                                                check = check ^ unsignedByteToInt(readBuffer[i]);
                                            }
                                            if ( check == unsignedByteToInt(readBuffer [readBuffer.length-1])) {
                                                goodresponse = true;
                                                System.out.print("read complete\n");
                                            } else {
                                                System.out.print("bad check byte\n");
                                                System.out.print("expected: " + check + "actual: " + readBuffer [readBuffer.length-1] + "\n");
                                            }
                                        }
                                    }
                                } else {
                                    System.out.print(waitstring);
                                    try {
                                            outputStream.write(0x00); 		/* keep forcing normally off mode */
                                        } catch (IOException e) {}
                                    try {
                                        Thread.currentThread().sleep(1000);
                                    } catch (InterruptedException e){}
                                }
                            }	while  (!goodresponse && running);
                        } catch (IOException e) {System.out.print("Read Error #2\n"); continue;}
                        if (goodresponse) {
                            System.out.print("control char" + Integer.toHexString((int)readBuffer[1]) +"\n");
                                ptr = 3;
                                frstopen = unsignedByteToInt(readBuffer[ptr++]) << 24;
                                frstopen += unsignedByteToInt(readBuffer[ptr++]) << 16;
                                frstopen += unsignedByteToInt(readBuffer[ptr++]) << 8;
                                frstopen += unsignedByteToInt(readBuffer[ptr++]);
                                
                                frstclose = unsignedByteToInt(readBuffer[ptr++]) << 24;
                                frstclose += unsignedByteToInt(readBuffer[ptr++]) << 16;
                                frstclose += unsignedByteToInt(readBuffer[ptr++]) << 8;
                                frstclose += unsignedByteToInt(readBuffer[ptr++]); 

                                secopen = unsignedByteToInt(readBuffer[ptr++]) << 24;
                                secopen += unsignedByteToInt(readBuffer[ptr++]) << 16;
                                secopen += unsignedByteToInt(readBuffer[ptr++]) << 8;
                                secopen += unsignedByteToInt(readBuffer[ptr++]); 
  
                                secclose = unsignedByteToInt(readBuffer[ptr++]) << 24;
                                secclose += unsignedByteToInt(readBuffer[ptr++]) << 16;
                                secclose += unsignedByteToInt(readBuffer[ptr++]) << 8;
                                secclose += unsignedByteToInt(readBuffer[ptr]);
                      
                                adjust4jitter();

                                 /* check for reversed sensor */
                                if (secopen-frstopen < 0) {
                                    exposure_right = frstclose-frstopen;
                                    exposure_left = secclose-secopen;
                                    speed_1st = frstopen-secopen;
                                    speed_2nd = frstclose-secclose;
                                } else {
                                    exposure_left = frstclose-frstopen;
                                    exposure_right = secclose-secopen;
                                    speed_1st = secopen-frstopen;
                                    speed_2nd = secclose-frstclose;
                                }
                                System.out.println("error"+readBuffer[2]);
//                                System.out.println("first open"+frstopen );
//                                System.out.println("first close"+frstclose );
//                                System.out.println("second open"+secopen );
//                                System.out.println("second close"+secclose );
                                if (exposure_left != 0)
                                    exposure_left = exposure_left/factor;
                                if (exposure_right != 0)
                                    exposure_right = exposure_right/factor;
                                if (speed_1st != 0)
                                    speed_1st = speed_1st/factor;
                                if (speed_2nd != 0)
                                    speed_2nd = speed_2nd/factor;
                               
                                System.out.println("exposure left: 1/"+exposure_left);
                                System.out.println("exposure right:  1/"+exposure_right);
                                System.out.println("speed first"+speed_1st );
                                System.out.println("speed second"+speed_2nd );
                                applet.newdata(readBuffer[2], true, exposure_left, exposure_right, speed_1st, speed_2nd);
                                result = 0;
                        }
                        Thread.yield();
		}
            }
	}

	Monitor (tester parent)
	{

            Enumeration portList;
            CommPortIdentifier portId;
            int i;
            boolean result;
            String theport = "none";
            serialPort = null;
		applet = parent;
//                while (parent.
 //                   Thread.yield();
			
 
            System.out.println("about to discover comm ports ");
            portList = CommPortIdentifier.getPortIdentifiers();
    
            /* build list of available com ports */
            portCount =0;
             while (portList.hasMoreElements()) {
                portId = (CommPortIdentifier) portList.nextElement();
                if (portId.getPortType() == CommPortIdentifier.PORT_SERIAL){
                        portCount ++;
                }  
            }
            if (portCount == 0) {
                System.out.println("no ports found");
                return;
            } else {
                list = new String [portCount];
                portCount = 0;
                    portList = CommPortIdentifier.getPortIdentifiers();
            
                    /* build list of available com ports */
                    while (portList.hasMoreElements()) {
                        portId = (CommPortIdentifier) portList.nextElement();
                        if (portId.getPortType() == CommPortIdentifier.PORT_SERIAL){
                                theport = portId.getName();
                                list[portCount] = theport;
                                System.out.println("found comm port:"+ theport);
                                portCount++;                    
                    }
                }
        }
        System.out.println("done discovering comm ports "+portCount+"found");

        //Group the radio buttons menus for all available com ports
        ButtonGroup group = new ButtonGroup();
        JMenu SerialPortMenu = new JMenu("portMenu");
        miPort = new JRadioButtonMenuItem [portCount];
        
        for (i = 0; i<portCount; i++) {
            miPort[i] = new JRadioButtonMenuItem(list[i]);
            SerialPortMenu.add(miPort[i]).setEnabled(true);
            miPort[i].addActionListener(this);
            group.add(miPort[i]);
            if (i == 0)
                miPort[i].setSelected(true);
        }
        parent.mainMenuBar.add(SerialPortMenu);
	parent.setJMenuBar (parent.mainMenuBar);
	
    
/*        String s = (String)JOptionPane.showInputDialog(
                        applet,
                        "Shutter Tester 2.0" +"\n" +
                        "Select COM port or Cancel to Exit",
                        applet.getTitle(),
                        JOptionPane.PLAIN_MESSAGE,
                        null,
                        list,
                        list[0]);
    */
        String s = list[portCount-1];
        //If a string was returned, say so.
        if ((s != null) && (s.length() > 0)) {
            openComPort(s);
        }
    }
    
    boolean openComPort (String s)
    {
        int i;
        Enumeration portList;
        CommPortIdentifier portId;
        String theport = "none";
        
        
        for (i = 0; i<portCount; i++) {
            if (list[i].equals(s))
                miPort[i].setSelected(true);
        }
        
        /* open selected com port */
        portList = CommPortIdentifier.getPortIdentifiers();
        while (portList.hasMoreElements()) {
            portId = (CommPortIdentifier) portList.nextElement();
            theport = portId.getName();
            if (theport.equals(s)) {
                try {
                    serialPort = (SerialPort)portId.open("ShutterProgram", 2000);
                    serialPort = serialPort;
                } catch (PortInUseException e) {return false;}	
                try {
                    outputStream = serialPort.getOutputStream();
                } catch (IOException e) {return false;}
                try {
                    inputStream = serialPort.getInputStream();
                } catch (IOException e) {return false;}
        
                try {
                    serialPort.setSerialPortParams(9600,
                        SerialPort.DATABITS_8,
                        SerialPort.STOPBITS_1,
                        SerialPort.PARITY_NONE);
                } catch (UnsupportedCommOperationException e) {return false;}
                try {
                    serialPort.setFlowControlMode(SerialPort.FLOWCONTROL_NONE);
                } catch (UnsupportedCommOperationException e) {return false;}
                try {
                    serialPort.enableReceiveTimeout(100);  /* 1 seconds */
                } catch (UnsupportedCommOperationException e) {return false;}
                if (!serialPort.isReceiveTimeoutEnabled())
                    System.out.println("no timeout comm port:"+ theport);  /* 5 seconds */
        
                System.out.println("selected and opened comm port:"+ theport);
                return true;
            }
        }
        return false;

    }
    
    boolean closeComPort ()
    {


        serialPort.close();
        System.out.println("closed comm port");
        return true;
    }

    // ActionListener interface (for menus)
    public void actionPerformed(ActionEvent newEvent) 
    {
        int i;
        String s;
        for (i = 0; i<portCount; i++) {
            if (newEvent.getActionCommand().equals(miPort[i].getActionCommand())) {
                s = miPort[i].getText();
                System.out.println("selected new comm port:"+ s);
                closeComPort();
                openComPort(s);
            }
        }
    }
	
 public static int unsignedByteToInt(byte b) {
    int i;
    i = (b & 0xFF);
//    System.out.println ("     "+i);
    return i;
    }
    
private void    adjust4jitter(){
	int fo_fact, so_fact, fc_fact, sc_fact;
        
        fo_fact = 6;
        fc_fact = 6;
        so_fact = 6;
        sc_fact = 6;
        
        if (frstopen == secopen) {
            fc_fact = 4;
            sc_fact = 4;
            if (frstclose < secclose) {
                sc_fact += 13;
            } else if (secclose < frstclose) {
                fc_fact += 14;
            }
        } else if (frstopen < secopen) {
            fc_fact = 8;
            so_fact = 8;
            sc_fact = 8;
            if (secopen < frstclose) {
                fc_fact += 15;
                sc_fact += 15;
                if (frstclose < secclose) {
                    sc_fact += 13;
                } else if ( secclose < frstclose) {
                    fc_fact += 14;
                }
            }
            else if (frstclose < secopen) {
                so_fact += 10;
                sc_fact += 22;
            } else /* (frstclose == secopen */{
                sc_fact += 26;
            }
        } else /* (secopen < firstopen) */ {
            fc_fact = 9;
            fo_fact = 9;
            sc_fact = 9;
            if (frstopen < secclose) {
                fc_fact += 15;
                sc_fact += 15;
                if (secclose < frstclose) {
                    fc_fact += 13;
                } else if ( frstclose < secclose) {
                    sc_fact += 14;
                }
            }
            else if (secclose < frstopen) {
                fo_fact += 10;
                fc_fact += 22;
            } else /* (frstclose == secopen */{
                  fc_fact += 26;
            }
        }

	frstopen = frstopen + fo_fact/13;
	frstclose = frstclose + fc_fact/13;
	secopen = secopen + so_fact/13;
        secclose = secclose + sc_fact/13;
    }
}