//
//  tester.java
//  tester
//
//  Copyright (c) 2005 Mike Willegal
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.


import java.util.Locale;
import java.util.ResourceBundle;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*; 
//import com.apple.mrj.*;
import java.io.*;



public class tester extends JFrame
                        implements  ActionListener {

    ConfigControls speeds, times, error, stability;
    CalControls calibrate;
    float cal_adjust, cal_effect;

    ConfigButtons cbut;
//    ConfigDecoder cdec;
    Monitor monitor;
    Thread T;
    JPanel panel;
    CardLayout card;
    JTabbedPane tpane;
    final String CONFIG_SCREEN = "Basic";
    final int CONFIG_NUM = 0;
    
    int cur_screen = 0;
    final String [] screens = {
            CONFIG_SCREEN};
    
    
    GridBagLayout gridbag;
    boolean CfgApplet;
    String title;

    protected ResourceBundle resbundle;
	
    // Declarations for menus
    static final JMenuBar mainMenuBar = new JMenuBar();
    
    JFileChooser chooser;
 
    protected JMenu fileMenu;
    protected JMenuItem miNew;
    protected JMenuItem miOpen;
    protected JMenuItem miClose;
    protected JMenuItem miSave;
    protected JMenuItem miSaveAs;
	
    protected JMenu editMenu;
    protected JMenuItem miUndo;
    protected JMenuItem miCut;
    protected JMenuItem miCopy;
    protected JMenuItem miPaste;
    protected JMenuItem miClear;
    protected JMenuItem miSelectAll;

    
    public void addFileMenuItems() {
        miNew = new JMenuItem (resbundle.getString("newItem"));
        miNew.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, Toolkit.getDefaultToolkit().getMenuShortcutKeyMask()));
        fileMenu.add(miNew).setEnabled(true);
        miNew.addActionListener(this);
		
        miOpen = new JMenuItem (resbundle.getString("openItem"));
        miOpen.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O, Toolkit.getDefaultToolkit().getMenuShortcutKeyMask()));
        fileMenu.add(miOpen).setEnabled(true);
        miOpen.addActionListener(this);
		
        miClose = new JMenuItem (resbundle.getString("closeItem"));
        miClose.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_W, Toolkit.getDefaultToolkit().getMenuShortcutKeyMask()));
        fileMenu.add(miClose).setEnabled(true);
        miClose.addActionListener(this);
		
        miSave = new JMenuItem (resbundle.getString("saveItem"),KeyEvent.VK_S);
        miSave.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, Toolkit.getDefaultToolkit().getMenuShortcutKeyMask()));
        fileMenu.add(miSave).setEnabled(true);
        miSave.addActionListener(this);
		
        miSaveAs = new JMenuItem (resbundle.getString("saveasItem"));
        miSaveAs.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, (java.awt.event.InputEvent.SHIFT_MASK | Toolkit.getDefaultToolkit().getMenuShortcutKeyMask())));
        fileMenu.add(miSaveAs).setEnabled(true);
        miSaveAs.addActionListener(this);
		
        mainMenuBar.add(fileMenu);
    }
	
	
    public void addEditMenuItems() {
        miUndo = new JMenuItem(resbundle.getString("undoItem"));
        editMenu.add(miUndo).setEnabled(false);
        miUndo.addActionListener(this);
        editMenu.addSeparator();
		
        miCut = new JMenuItem(resbundle.getString("cutItem"));
        editMenu.add(miCut).setEnabled(false);
        miCut.addActionListener(this);
		
        miCopy = new JMenuItem(resbundle.getString("copyItem"));
        editMenu.add(miCopy).setEnabled(false);
        miCopy.addActionListener(this);
		
        miPaste = new JMenuItem(resbundle.getString("pasteItem"));
        editMenu.add(miPaste).setEnabled(false);
        miPaste.addActionListener(this);
		
        miClear = new JMenuItem(resbundle.getString("clearItem"));
        editMenu.add(miClear).setEnabled(false);
        miClear.addActionListener(this);
        editMenu.addSeparator();
		
        miSelectAll = new JMenuItem(resbundle.getString("selectAllItem"));
        editMenu.add(miSelectAll).setEnabled(false);
        miSelectAll.addActionListener(this);
		
        mainMenuBar.add(editMenu);
    }
	
    public void addMenus() {
        editMenu = new JMenu(resbundle.getString("editMenu"));
        fileMenu = new JMenu(resbundle.getString("fileMenu"));
        addFileMenuItems();
        addEditMenuItems();
        setJMenuBar (mainMenuBar);
    }
	
	
    public tester() {
        super("untitled.sht");
        CfgApplet = false;
        MainConstruct  (760,450);

        WindowAdpt WAdapter = new WindowAdpt();
        this.addWindowListener(WAdapter);
                                
        // The ResourceBundle below contains all of the strings used in this application.  ResourceBundles
        // are useful for localizing applications - new localities can be added by adding additional 
        // properties files.  
        resbundle = ResourceBundle.getBundle("testerstrings", Locale.getDefault());
        setTitle (resbundle.getString("frameConstructor"));
        addMenus();
		
        Toolkit.getDefaultToolkit();
        
        doNew();

        handleAbout();
        initChooser();
        setVisible(true); 
        monitor = new Monitor(this);
        T = new Thread(monitor);
        T.start();

      
    }
	
    
    public void handleAbout()
    {
        System.out.println("about to disply start up box ");
        new StartupBox2(this);
    }
	
    public void handleQuit()
    {	
        // If the application needs to save document/state before exiting, do so here
        System.exit(0);
    }
    
    void initChooser ()
    {
        ShutterFilter shutterFilter = new ShutterFilter();
        chooser = new JFileChooser();
        chooser.setFileFilter(shutterFilter);

   }

    // ActionListener interface (for menus)
    public void actionPerformed(ActionEvent newEvent) 
    {
        if (newEvent.getActionCommand().equals(miNew.getActionCommand())) doNew();
        else if (newEvent.getActionCommand().equals(miOpen.getActionCommand())) doOpen();
        else if (newEvent.getActionCommand().equals(miClose.getActionCommand())) doClose();
        else if (newEvent.getActionCommand().equals(miSave.getActionCommand())) doSave();
        else if (newEvent.getActionCommand().equals(miSaveAs.getActionCommand())) doSaveAs();
        else if (newEvent.getActionCommand().equals(miUndo.getActionCommand())) doUndo();
        else if (newEvent.getActionCommand().equals(miCut.getActionCommand())) doCut();
        else if (newEvent.getActionCommand().equals(miCopy.getActionCommand())) doCopy();
        else if (newEvent.getActionCommand().equals(miPaste.getActionCommand())) doPaste();
        else if (newEvent.getActionCommand().equals(miClear.getActionCommand())) doClear();
        else if (newEvent.getActionCommand().equals(miSelectAll.getActionCommand())) doSelectAll();
    }
	
    public void doNew() {
        String txt;
        int i = 1;
        default_settings();
        txt = "untitled.sht";
        
        while (true) {
            try {
                FileInputStream s = new FileInputStream(txt);
                i++;
                txt = "untitled" + i + ".sht";
                s.close();
            } catch (IOException e) {
                setTitle(txt);
                cbut.status.setText("OK");
                repaint ();
                return;
            }
        }
    }
	
    public void doOpen() {
        int i, returnVal;
        float exposure_left;
        float exposure_right;
        float speed_1st;
        float speed_2nd;
        float reserved, adjust, effect;
        String txt;
        chooser.rescanCurrentDirectory();
        returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            txt = chooser.getSelectedFile().getName();
            System.out.println("You chose to open this file: " + txt);
            setTitle(txt);
            try {
            FileInputStream s = new FileInputStream(txt);
            ObjectInputStream is = new ObjectInputStream(s);

                try{
                        for (i = 0; i<speeds.numberofspeeds; i++) {
                                txt = (String)is.readObject();
                                exposure_left= Float.parseFloat(txt);
                                txt = (String)is.readObject();
                                exposure_right= Float.parseFloat(txt);
                                txt = (String)is.readObject();
                                speed_1st= Float.parseFloat(txt);
                                txt = (String)is.readObject();
                                speed_2nd= Float.parseFloat(txt);
                                setspeed(i);
                                newdata ((byte)0, false, exposure_left, exposure_right, speed_1st, speed_2nd);
                        }
                        txt = (String)is.readObject();
                        adjust = Float.parseFloat(txt);
                        txt = (String)is.readObject();
                        effect = Float.parseFloat(txt);
                        newcal (adjust, effect);
                        txt = (String)is.readObject();
                        reserved=Float.parseFloat(txt);
                } catch (ClassNotFoundException ce) {
                        cbut.status.setText("read fail");
                        is.close();
                        s.close();
                        repaint ();
                        return;
                }
            is.close();
            s.close();
//            speeds.default_settings();
            } catch (IOException e) {
                    cbut.status.setText("failure to read configuration");
                    repaint ();
                    return;
            }
        }

}
	
    public void doClose() {
    }
	
    public void doSave() {
        String txt;
            txt= getTitle();
            writeFile(txt);
    }
	
    public void doSaveAs() {
        int i, returnVal;
        String txt, ext;
        ext = null;
        chooser.rescanCurrentDirectory();
        returnVal = chooser.showSaveDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            txt = chooser.getSelectedFile().getName();
            i = txt.lastIndexOf('.');
            if (i > 0 &&  i < txt.length() - 1) {
                ext = txt.substring(i+1).toLowerCase();
            }

            if (ext == null || !(ext.equals(Utils.sht))) {
                txt = txt + "." +  Utils.sht;
            }
            try {
                FileInputStream s = new FileInputStream(txt);
                s.close();
                int result = JOptionPane.showOptionDialog(this, "File "+txt+" exists, overwrite?", "Warning",              
                JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE, null, null, null);
                if (result != 0) {
                    cbut.status.setText("save cancelled by user");
                    return;
                }
            } catch (IOException e) {
            }
            setTitle(txt);
            writeFile(txt);
            repaint ();
            return;
        } else {
                cbut.status.setText("save cancelled by user");
        }

    }
	
    public void doUndo() {
    }
	
    public void doCut() {
    }
	
    public void doCopy() {
    }
	
    public void doPaste() {
    }
	
    public void doClear() {
    }
	
    public void doSelectAll() {
    }
	
    class WindowAdpt extends java.awt.event.WindowAdapter {
        public void windowClosing(java.awt.event.WindowEvent event) {
            handleQuit();
        }
    }


void writeFile (String txt)
{
    int i;
        System.out.println("You chose to save this file: " + txt);

        try {
        FileOutputStream s = new FileOutputStream(new File(txt));
        ObjectOutputStream os = new ObjectOutputStream(s);

        for (i = 0; i<speeds.numberofspeeds; i++) {
                txt = String.valueOf (speeds.rec_exposure_left[i]);
                os.writeObject(txt);
                txt = String.valueOf (speeds.rec_exposure_right[i]);
                os.writeObject(txt);
                txt = String.valueOf (speeds.rec_speed_1st[i]);
                os.writeObject(txt);
                txt = String.valueOf (speeds.rec_speed_2nd[i]);
                os.writeObject(txt);
        }
        txt = String.valueOf (cal_adjust);
        os.writeObject(txt);
        txt = String.valueOf (cal_effect);
        os.writeObject(txt);
        txt = String.valueOf (0.0);  // reserve space for one float
        os.writeObject(txt);
        

        os.flush();
        os.close();
        s.close();
        } catch (IOException e) {
                cbut.status.setText("failure to save configuration");
                return;
        }
       cbut.status.setText("OK");
}
   
    public static void main(String args[]) {
        System.setProperty("apple.laf.useScreenMenuBar", "true");
        WindowUtilities.setNativeLookAndFeel();
        new tester();
    }
        
    private void MainConstruct  (int hsize, int vsize)
    {
                    setSize(hsize,vsize);
                    setLocation(new Point(40,40));
     
                    Container pane = getContentPane();
                    
                    Font f = new Font("TimesRoman", Font.PLAIN,12);	
                    setFont(f);
                                    
                    
                    pane.setLayout(new BorderLayout());
                    tpane = new JTabbedPane();
     
    
                    speeds = new ConfigControls (this);
                    times = new TimeControls(this);
                    error = new ErrorControls (this);
                    stability = new StableControls (this);
                    calibrate = new CalControls (this);
                    tpane.addTab("Speeds", null, speeds);
                    tpane.addTab("Times", null, times);
                    tpane.addTab("Error", null, error);
                    tpane.addTab("Stability", null, stability);
                    tpane.addTab("Calibrate", null, calibrate);
                    
                    pane.add (tpane,BorderLayout.CENTER);
            
    
                    cbut = new ConfigButtons (this);
                    pane.add (cbut, BorderLayout.PAGE_END);
                                        
 //                   setVisible(true);
    }
    
    
    void buildConstraints(GridBagConstraints gbc, int gx, int gy,
                    int gw, int gh, int wx, int wy) {
            gbc.gridx = gx;
            gbc.gridy = gy;
            gbc.gridwidth = gw;
            gbc.gridheight = gh;
            gbc.weightx = wx;
            gbc.weighty = wy;
            }
    

    public void default_settings ()
    {
            speeds.default_settings();
            times.default_settings();
            error.default_settings();
            stability.default_settings();
            calibrate.default_settings();
             
    }
 
    
    public void newdata (byte err,  boolean autospeed, float exposure_left, float exposure_right, float speed_1st, float speed_2nd)
    {
	speeds.newdata(err, autospeed, exposure_left, exposure_right, speed_1st, speed_2nd);
	times.newdata(err, autospeed, exposure_left, exposure_right, speed_1st, speed_2nd);
	error.newdata(err, autospeed, exposure_left, exposure_right, speed_1st, speed_2nd);
	stability.newdata(err, autospeed, exposure_left, exposure_right, speed_1st, speed_2nd);
        calibrate.newdata(err, autospeed, exposure_left, exposure_right, speed_1st, speed_2nd);

    }
    
    public void newdata_row (int speed, float exposure_left, float exposure_right, float speed_1st, float speed_2nd)
    {
	speeds.newdata_row(speed, exposure_left, exposure_right, speed_1st, speed_2nd);
	times.newdata_row(speed, exposure_left, exposure_right, speed_1st, speed_2nd);
	error.newdata_row(speed, exposure_left, exposure_right, speed_1st, speed_2nd);
	stability.newdata_row(speed, exposure_left, exposure_right, speed_1st, speed_2nd);

    }

     public void newcal (float adjustment, float effect)
    {
        cal_adjust = adjustment;
        cal_effect = effect;
	speeds.newcal(adjustment, effect);
	times.newcal(adjustment, effect);
	error.newcal(adjustment, effect);
	stability.newcal(adjustment, effect);
    }

    public void autoSpeed (boolean autospeed)
    {
        speeds.autoSpeed(autospeed);
        times.autoSpeed(autospeed);
	error.autoSpeed(autospeed);
	stability.autoSpeed(autospeed);
        calibrate.autoSpeed(autospeed);
    }

    public void setspeed (int speed)
    {
	speeds.setspeed(speed);
	times.setspeed(speed);
	error.setspeed(speed);
	stability.setspeed(speed);
    }
    
    public void calEnable (boolean cal)
    {
        speeds.calEnable(cal);
        times.calEnable(cal);
	error.calEnable(cal);
	stability.calEnable(cal);
        calibrate.calEnable(cal);
    }

}
